html2meta <- function(html, mode="UTF8") {
  print(html)
  name <- stringr::str_remove(html,"/.+/")
  htmltext <- readLines(html)
  tmp <- stringr::str_remove(stringr::str_remove(stringr::str_remove(htmltext[grep("td",iconv(htmltext, from="WINDOWS-1250", to=mode))],"      <td.+\">"),"</.+td>"),"<.+>")
  exp <- stringr::str_remove(tmp[3],"&nbsp;")
  qth <- stringr::str_remove(tmp[5],"&nbsp;")
  loc <- stringr::str_remove(tmp[7],"&nbsp;")
  ele <- stringr::str_remove(tmp[9],"&nbsp;")
  beg <- stringr::str_remove(tmp[11],"&nbsp;")
  end <- stringr::str_remove(tmp[13],"&nbsp;")
  ops <- stringr::str_remove(tmp[15],"&nbsp;")
  opl <- stringr::str_remove(tmp[17],"&nbsp;")
  trx <- stringr::str_remove(tmp[19],"&nbsp;")
  ant <- stringr::str_remove(tmp[21],"&nbsp;")
  mod <- stringr::str_remove(tmp[23],"&nbsp;")
  frq <- stringr::str_remove(tmp[25],"&nbsp;")
  note <- stringr::str_remove(tmp[27],"&nbsp;")
  cat <- stringr::str_remove(tmp[29],"&nbsp;")
  cba <- stringr::str_remove(tmp[31],"&nbsp;")
  if(grepl("Ano",cba)) {
    cba <- T
  } else {
    cba <- F
  }
  num <- as.numeric(stringr::str_remove(stringr::str_remove(tmp[33],"&nbsp;")," spo.+"))
  kmt <- as.numeric(stringr::str_remove(stringr::str_remove(tmp[35],"&nbsp;")," km"))
  kma <- as.numeric(stringr::str_remove(stringr::str_remove(tmp[37],"&nbsp;")," km.+"))
  see <- as.numeric(stringr::str_remove(stringr::str_remove(tmp[39],"&nbsp;")," shl.+"))
  return(list(id=name, expedition=exp, qth=qth, loc=loc, elevation=ele, beg=beg, end=end, operators=ops, loggers=opl, trx=trx, ant=ant, mode=mod, freq=frq, note=note, category=cat, cb_activity=cba, num=num, km_total=kmt, km_average=kma, num_seen=see))
}