readapache <-
function(file, mode="ASCII//TRANSLIT") {
  df <- read.table(file, sep=",", header=F, skip=1, fill=T)
  str_extract(df[,4],"RS .....")
  df$report_out <- gsub('RS (..)/..', '\\1', str_extract(df[,4],"RS ....."))
  df$report_in <- gsub('RS ../(..)', '\\1', str_extract(df[,4],"RS ....."))
  df$V4 <- gsub('(.*)RS ../..(.*)', '\\1 \\2', df$V4)
  df$id <- rownames(df)
  date_time <- gsub('2...-..-.. (.+)','\\1',strftime(as.POSIXlt(as.character(df[,1]),format="%H:%M", tz=""), usetz=F))
  header_date <- rep(strftime(as.POSIXlt(as.character(gsub('.+[,; ]([0-9]+.[0-9]+. *20..)[,; ]*.*','\\1',readLines(file, n=1))),format="%d.%m.%Y", tz=""), usetz=F),length(df[,1]))
  df$date_time <- paste(header_date,date_time)
  df$locator_out <- rep(gsub('.+,([A-Z][A-Z][0-9][0-9][A-Z][A-Z]),*.*','\\1',readLines(file, n=1)),length(rownames(df)))
  df$dist <- rep(NA,length(rownames(df)))
  df <- df[,c(9,7,8,5,2,6,3,10,4)]
  colnames(df) <- c("locator_out","id","date_time","report_out","qth_in","report_in","locator_in","dist","note")
  return(df[,1:9])
}
