readcl6 <-
function(file, mode="ASCII//TRANSLIT", date_from_header=FALSE) {
  df <- read.table(file, sep=";", header=F, skip=1)
  colnames(df) <- c("locator_out","id","date_time","report_out","qth_in","report_in","locator_in","dist","note")
  if(date_from_header) {
    if(grepl("202",df[1,3])) {
      date_time <- gsub('2...-..-.. (.+)','\\1',strftime(as.POSIXlt(as.character(df[,3]),format="%H:%M:%OS", tz=""), usetz=F))
    } else {
      date_time <- gsub('2...-..-.. (.+)','\\1',strftime(as.POSIXlt(as.character(df[,3]),format="%H:%M:%OS", tz=""), usetz=F))
    }
    header_date <- rep(strftime(as.POSIXlt(as.character(gsub('.+[,; ]([0-9]+.[0-9]+. *20..)[,; ]*.*','\\1',readLines(file, n=1))),format="%d.%m.%Y", tz=""), usetz=F),length(df[,1]))
    df$date_time <- paste(header_date,date_time)
  } else {
    df$date_time <- strftime(as.POSIXlt(as.character(df$date_time),format="[%d.%m.%Y] %H:%M:%OS", tz=""), usetz=F)
  }
  df$qth_in <- iconv(df$qth_in, from="WINDOWS-1250", to=mode)
  return(df[,1:9])
}
