\name{cbpmr_harvester}
\alias{cbpmr_harvester}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Harvest web calendars for Apache's map data}
\description{
  A function to harvest CB and PMR events from webpages for Apache's map
  with chunks of code for each URL. Requires library(rvest).
}
\usage{
cbpmr_harvest(name="", all=TRUE, header=TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{file}{
    cbpmr_harvest(NAME, OPTIONS])
}
}
\details{
  NAME	Name of one of the calendar sources (see if statements in code)
}
\value{
  date.frame
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
  Matej Lexa
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.
cbpmr_harvest()

## The function is currently defined as
function(name="", all=TRUE, header=TRUE) {

  df <- data.frame(matrix(ncol = 7, nrow = 0), stringsAsFactors = FALSE)
  colnames(df) <- c("zdroj","lokator","nazev","misto","text","datum","cas")

  if((name == "cb21_praha") || (all == TRUE)) {

      name_string <- "cb21_praha"
      url <- "http://cb21.wz.cz/kalendar.php"
      webpage <- read_html(url)

      datum_html <- html_nodes(webpage,'span')
      datum_data <- html_text(datum_html)

      date <- datum_data[seq(8,length(datum_data), by=2)]
      # date
      # [1] "27. 4. 2019"  "8. 6. 2019"   "31. 12. 2019" "31. 12. 2019"
      hour <- datum_data[seq(9,length(datum_data), by=2)]
      # hour
      # [1] "11:00" "22:00" "12:00" "12:00"

      nazev_html <- html_nodes(webpage,'.kalendar_nadpis')
      nazev_data <- html_text(nazev_html) %>% as.character() %>% regexPipes::gsub("\n +","") %>% regexPipes::gsub("\r\n *","")
      #nazev_data <- html_text(nazev_html) %>% as.character() %>% regexPipes::gsub("\n +","") %>% regexPipes::gsub("[\n\r]+.+","") %>% regexPipes::gsub("\n.+","")
      title <- nazev_data
      title <- unlist(lapply(nazev_data,function(x){gsub("\n +","",x)}))
      # title
      # [1] "Setkání v restauraci U černého koně ( Žernovka )"
      # [2] "Rozhledny 2019"
      # [3] "Pražské polední kolečko na kanále C18 (náhradní kanál B18 (57))"
      # [4] "Pražský CB bazar"

      text_html <- html_nodes(webpage,'.kalendar')
      text_data <- html_text(text_html) %>% as.character() %>% regexPipes::gsub("\n +","") %>% regexPipes::gsub("[\n\r]+.+","") %>% regexPipes::gsub("\n.+","")
      text <- text_data[seq(4,length(text_data), by=3)]
      # text
      # [1] "Jarní setkání CB-čkářů se koná v restauraci U černého koně (Modřanská 94, Praha-Hodkovičky, roh ulic Modřanská a V Hodkovičkách)v sobotu 27. dubna od 11:00 hod. Srdečně zve Jiřina Písnice"                                                                                                                                                                                                                                                                                                                                                     
      # [2] "Letošní ročník Rozhleden se koná v pásmu B na kanálech 35 nebo náhr. 38 (pro majitele 80. kanálových stanic jsou to kanály 75 nebo 78) v noci ze soboty 8. června na neděli 9. června.Soutěžní část akce Rozhledny 2019 začíná ve 22:00 a je jako obvykle složena ze třech kontrolních stanic, se kterými je třeba se spojit dvakrát. Samotný řetězec Rozhleden se rozběhne v 01:00 a bude jako obvykle dvoukolový.Přihlašovací formulář a seznam rozhleden zde bude připraven od 1. května                    Srdečně zve Jiřina Písnice a kol."
      # [3] "Každý den se můžete přesně v poledne zúčastnit na pravidelném poledním kolečku Jiřiny Písnice, ve kterém se dozvíte mimo předpovědi počasí a novinek ze světa CB také to, co kdo právě jí dobrého... . Každý čtvrtek je také součástí úvodní části poledního kolečka pražský CB bazar. Vzhledem k obrovskému rušení v C pásmu v současné době může být bazar vysílán na náhradním kanále B18 (57).Srdečně zve Jiřina Písnice. "                                                                                                                  
      # [4] "Vzhledem k malému počtu inzerátů se CB bazar vysílá živě každý čtvrtek v úvodní části poledního kolečka na kanále C18. Inzeráty můžete vkládat zde do rubriky CB bazar. Budu zde také připisovat inzeráty cb-čkářů, kteří internet nemají a podají si inzerát na CB nebo pomocí SMS na tel. 608 - 54 18 16.  Tak si mohou všichni, co nemají možnost si CB bazar ve čtvrtek v poledne poslechnout, inzeráty přečíst.      Jiřina Písnice"                                                                                                        

      df2 <- data.frame(rep(name_string,length(date)),rep("",length(date)),title,rep("",length(date)),text,date,hour, stringsAsFactors = FALSE)
      colnames(df2) <- c("zdroj","lokator","nazev","misto","text","datum","cas")
      df <- rbind(df,df2, make.row.names = FALSE, stringsAsFactors = FALSE)

  }

  if((name == "cbmonitor_cb") || (all == TRUE)) {

      name_string <- "cbmonitor_cb"
      url <- "http://cbmonitor.net/kalendar/index1.php?t=&mesic=&lk=CB"
      webpage <- read_html(url)

      date_selection <- webpage %>% html_nodes("center") %>% html_nodes("td") %>% html_nodes("time") %>% as.character %>% regexPipes::grep("startDate")
      datum_data <- webpage %>% html_nodes("center") %>% html_nodes("td") %>% html_nodes("time") %>% extract(date_selection) %>% regexPipes::gsub("<[^<>]+>","") %>% regexPipes::gsub(" $"," 00:00")
      datum_data <- as.character(unlist(sapply(datum_data,strsplit,split=" ")))
      date <- datum_data[seq(1,length(datum_data), by=2)]
      # date
      # [1] "27.04.2019" "27.04.2019" "03.05.2019" "04.05.2019" "18.05.2019" "24.05.2019"
      hour <- datum_data[seq(2,length(datum_data), by=2)]
      # hour
      # [1] "09:00" "11:00" "16:00" "00:00" "13:00" "00:00"

      info_html <- webpage %>% html_nodes("center") %>% html_nodes("span")
      info_data <- html_text(info_html)
      title <- info_data[seq(1,length(info_data), by=6)]
      # title
      # [1] "Sraz CB-AMA v Havrani u Mostu"         
      # [2] "Setkání U Černého koně"                
      # [3] "CB/PMR stretnutie REMATA"              
      # [4] "22. CB a AMA setkání"                  
      # [5] "Setkání HAM a CB"                      
      # [6] "XXVI. setkání HAM a CB Pražák u Vodňan"

      text <- info_data[seq(6,length(info_data), by=6)]
      # text
      # [1] "Sraz CB-AMA  v Havrani u Mostu se koná v sále místní sokolovny, občerstvení zajištěno. Všichni jsou srdečně zváni!"                                                                                
      # [2] "Setkání CB, AMA,PMR a.j. v sobotu 27 dubna v 11:00 v restauraci U Černého koně, Modřanská 8, tramvaj číslo 17 zastávka Černý kůň.\r\n\r\nZve Jiřina Písnice a spol."                               
      # [3] "Tradičné stretnutie užívateľov občianskeho pásma v rekreačnej oblasti Remata. Stretneme sa v priestoroch chaty Poniklec."                                                                          
      # [4] "22. CB a AMA setkání se koná 4. a 5. května 2019."                                                                                                                                                 
      # [5] "Od 13:00 hod. se koná setkání HAM a CB v restauraci Na Garážích v Kladně na rohu ulic Železničářů a Wolkerova. Navigace na OK0K 145.750 MHz a OK0BK 439.000 MHz. Všechny srdečně zve Silva, OK1CEP"
      # [6] "XXVI. setkání HAM a CB Pražák u Vodňan 2018 se bude konat 24. - 25. května. Více na našem webu."

      locator <- info_data[seq(3,length(info_data), by=6)] %>% regexPipes::sub("^.*\\(","") %>% regexPipes::sub("\\).*$","")
      # locator
      # [1] "JO60TK" "JO70EA" "JN98JS" "JO70XC" "JO70BD" "JN79BD"

      place <- info_data[seq(3,length(info_data), by=6)] %>% regexPipes::sub(" \\(.*$","")
      # place
      # [1] "Havraň" "Praha 4 - Hodkovičky" "REMATA" "Holice" "Kladno" "Pražák" 

      df2 <- data.frame(rep(name_string,length(date)),locator,title,place,text,date,hour, stringsAsFactors = FALSE)
      colnames(df2) <- c("zdroj","lokator","nazev","misto","text","datum","cas")
      df<- rbind(df,df2, make.row.names = FALSE, stringsAsFactors = FALSE)

  }

  if((name == "cbmonitor_pmr") || (all == TRUE)) {

      name_string <- "cbmonitor_pmr"
      url <- "http://cbmonitor.net/kalendar/index1.php?t=&mesic=&lk=PMR"
      webpage <- read_html(url)

      date_selection <- webpage %>% html_nodes("center") %>% html_nodes("td") %>% html_nodes("time") %>% as.character %>% regexPipes::grep("startDate")
      datum_data <- webpage %>% html_nodes("center") %>% html_nodes("td") %>% html_nodes("time") %>% extract(date_selection) %>% regexPipes::gsub("<[^<>]+>","") %>% regexPipes::gsub(" $"," 00:00")
      datum_data <- as.character(unlist(sapply(datum_data,strsplit,split=" ")))
      date <- datum_data[seq(1,length(datum_data), by=2)]
      # date
      # [1] "27.04.2019" "27.04.2019" "03.05.2019" "04.05.2019" "18.05.2019" "24.05.2019"
      hour <- datum_data[seq(2,length(datum_data), by=2)]
      # hour
      # [1] "09:00" "11:00" "16:00" "00:00" "13:00" "00:00"

      info_html <- webpage %>% html_nodes("center") %>% html_nodes("span")
      info_data <- html_text(info_html)
      title <- info_data[seq(1,length(info_data), by=6)]
      # title
      # [1] "Sraz CB-AMA v Havrani u Mostu"         
      # [2] "Setkání U Černého koně"                
      # [3] "CB/PMR stretnutie REMATA"              
      # [4] "22. CB a AMA setkání"                  
      # [5] "Setkání HAM a CB"                      
      # [6] "XXVI. setkání HAM a CB Pražák u Vodňan"

      text <- info_data[seq(6,length(info_data), by=6)]
      # text
      # [1] "Sraz CB-AMA  v Havrani u Mostu se koná v sále místní sokolovny, občerstvení zajištěno. Všichni jsou srdečně zváni!"                                                                                
      # [2] "Setkání CB, AMA,PMR a.j. v sobotu 27 dubna v 11:00 v restauraci U Černého koně, Modřanská 8, tramvaj číslo 17 zastávka Černý kůň.\r\n\r\nZve Jiřina Písnice a spol."                               
      # [3] "Tradičné stretnutie užívateľov občianskeho pásma v rekreačnej oblasti Remata. Stretneme sa v priestoroch chaty Poniklec."                                                                          
      # [4] "22. CB a AMA setkání se koná 4. a 5. května 2019."                                                                                                                                                 
      # [5] "Od 13:00 hod. se koná setkání HAM a CB v restauraci Na Garážích v Kladně na rohu ulic Železničářů a Wolkerova. Navigace na OK0K 145.750 MHz a OK0BK 439.000 MHz. Všechny srdečně zve Silva, OK1CEP"
      # [6] "XXVI. setkání HAM a CB Pražák u Vodňan 2018 se bude konat 24. - 25. května. Více na našem webu."

      locator <- info_data[seq(3,length(info_data), by=6)] %>% regexPipes::sub("^.*\\(","") %>% regexPipes::sub("\\).*$","")
      # locator
      # [1] "JO60TK" "JO70EA" "JN98JS" "JO70XC" "JO70BD" "JN79BD"

      place <- info_data[seq(3,length(info_data), by=6)] %>% regexPipes::sub(" \\(.*$","")
      # place
      # [1] "Havraň" "Praha 4 - Hodkovičky" "REMATA" "Holice" "Kladno" "Pražák" 

      df2 <- data.frame(rep(name_string,length(date)),locator,title,place,text,date,hour, stringsAsFactors = FALSE)
      colnames(df2) <- c("zdroj","lokator","nazev","misto","text","datum","cas")
      df <- rbind(df,df2, make.row.names = FALSE, stringsAsFactors = FALSE)

  }

  return(df)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }% use one of  RShowDoc("KEYWORDS")
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
